/*
*********************************************************************************************************
*                                                uC/OS-II
*                                          The Real-Time Kernel
*
*                          (c) Copyright 1992-2002, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
*
*                                           uCOS_51 for MCS-51
*
* File : serial.c
* From : yang yi
* Last modified by : QQ 591881218
*********************************************************************************************************
*/

#ifndef  OS_MASTER_FILE
#include "..\..\ucos-ii\inc\includes.h"
#endif

unsigned char TxBuf[LenTxBuf],RxBuf[LenRxBuf];
unsigned char *inTxBuf,*outTxBuf,*inRxBuf,*outRxBuf;
bit TIflag = 1;
/////////////////////////////////////////////////////////////////////////////
void InitSerial(uint8_t uart_x,unsigned long int baut_x) large reentrant // ڳʼ
{
	unsigned long int temp_baut;

	temp_baut = sys_clk >> 2;
	temp_baut /= baut_x;
	temp_baut = 65536 - temp_baut;
	switch(uart_x)
	{
		case system_uart:
		{
			TR1 = 0;		
			SCON = 0x50;		//8λ,ɱ䲨			
			TMOD &= 0x0F;		//趨ʱ1Ϊ16λԶװʽ
			TL1 = temp_baut;		//趨ʱֵ
			TH1 = temp_baut >> 8;		//趨ʱֵ
			AUXR |= 0x40;		//ʱ1ʱΪFosc,1T
			AUXR &= 0xF6;		//1ѡʱ1Ϊʷ
			ET1 = 0;		//ֹʱ1ж
			TR1 = 1;		//ʱ1
			break;
		}
		case speaker_uart:
		{
			S2CON = 0x10;		//8λ,ɱ䲨
			AUXR |= 0x04;		//ʱ2ʱΪFosc,1T
			T2L = temp_baut;		//趨ʱֵ
			T2H = temp_baut >> 8;		//趨ʱֵ
			AUXR |= 0x10;		//ʱ2
			IE2 |= ES2;
			break;
		}
		case wireless_uart:
		{
			S3CON = 0x50;		//8λ,ɱ䲨
			T3L = temp_baut;		//趨ʱֵ
			T3H = temp_baut >> 8;		//趨ʱֵ
			T4T3M |= 0x0a;		//ʱ3
			IE2 |= ES3;
			break;
		}
		case uart_4:
		{
			S4CON = 0x50;		//8λ,ɱ䲨
			T4L = temp_baut;		//趨ʱֵ
			T4H = temp_baut >> 8;		//趨ʱֵ
			T4T3M |= 0xa0;		//ʱ4
			IE2 |= ES4;
			break;
		}
	}
}
/////////////////////////////////////////////////////////////////////////////
void InitSerialBuffer(void) large reentrant // ڻʼ
{
	inTxBuf = TxBuf;
	outTxBuf = TxBuf;
	inRxBuf = RxBuf;
	outRxBuf = RxBuf;
	ES=1;
}
/////////////////////////////////////////////////////////////////////////////
void Serial(void) large reentrant	// жϷӳжڻʵ֣ȥinterrupt UART1_VECTOR 
{  
	unsigned char *t;
	
	/* ѭ */
	if(TI)
	{
		TI=0;
		if(inTxBuf == outTxBuf)
		{
			TIflag=1;
			return;
		} // TxBuf Empty
		SBUF = *outTxBuf;
		outTxBuf++;
		if(outTxBuf == (TxBuf + LenTxBuf))
		{
			outTxBuf = TxBuf;
		}			
	}
	if(RI)
	{
		RI = 0;
		t = inRxBuf;
		t++;
		if(t == (RxBuf + LenRxBuf))
		{
			t = RxBuf;
		}
		if(t == outRxBuf) return; // RxBuf Full
		*inRxBuf = SBUF;
		inRxBuf = t;
	}
}
/////////////////////////////////////////////////////////////////////////////
bit Getch(unsigned char *ch) large reentrant // Ӵڻ1ֽ
{
#if OS_CRITICAL_METHOD == 3                                /* Allocate storage for CPU status register */
    OS_CPU_SR  cpu_sr;
#endif
	
	OS_ENTER_CRITICAL();/* ٽ */      
	if(inRxBuf==outRxBuf)
	{
		OS_EXIT_CRITICAL();/* ˳ٽ */
		return 0;
	} // RxBuf Empty
	*ch = *outRxBuf;
	outRxBuf++;
	if(outRxBuf == (RxBuf+LenRxBuf))
	{
		outRxBuf=RxBuf;
	}
	OS_EXIT_CRITICAL();/* ˳ٽ */     
	return 1;
}
/////////////////////////////////////////////////////////////////////////////
void PrintChar(unsigned char ch) large reentrant // ʾַ
{
#if OS_CRITICAL_METHOD == 3                                /* Allocate storage for CPU status register */
    OS_CPU_SR  cpu_sr;
#endif

	unsigned char *t;

	OS_ENTER_CRITICAL();/* ٽ */

/*
#pragma ASM
    PUSH IE; // ж״̬
    CLR EA; // ж
#pragma ENDASM
*/

	t = inTxBuf;
	t++;
	if(t == (TxBuf + LenTxBuf))
	{
		t = TxBuf;
	}
	if(t == outTxBuf)
	{
		OS_EXIT_CRITICAL();/* ˳ٽ */

		/*
		#pragma ASM
		    POP IE;	// ָ֮ǰж״̬
		#pragma ENDASM
		*/

		return;
	} // TxBuf Full
	*inTxBuf = ch;
	inTxBuf = t;

	OS_EXIT_CRITICAL();/* ˳ٽ */

/*
#pragma ASM
    POP IE; // ָ֮ǰж״̬
#pragma ENDASM
*/

	if(TIflag)
	{	
		OS_ENTER_CRITICAL();/* ٽ */	
		TIflag = 0;
		OS_EXIT_CRITICAL();/* ˳ٽ */ 
		TI = 1; // ڷж	
	}
}
/////////////////////////////////////////////////////////////////////////////
void PrintStr(unsigned char *str) large reentrant // ʾַ
{ 
	int i;
	unsigned char j;
	unsigned char ch;
		
/*
#pragma ASM
    PUSH IE;
    CLR EA;
#pragma ENDASM
*/
    /* Ҫٽ籣 */
	for(i = 0;i < MaxLenStr;i++)
	{
		ch = *(str + i);
		if(ch == '\0')
		{
			break;
		}
		else if(ch == '\n')
		{
			PrintChar(10);
			PrintChar(13);
		} 
		else if(ch == '\t')
		{
			for(j = 0;j < TABNum;j++)
			{
				PrintChar(' ');
			}
		}
		else
		{
			PrintChar(ch);
		}
	}

/*
#pragma ASM
    POP IE;
#pragma ENDASM
*/
}
/////////////////////////////////////////////////////////////////////////////
void ClrScr(void) large reentrant // 
{        
	PrintStr("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"); // 25س
}

