/*
*********************************************************************************************************
*                                                uC/OS-II
*                                          The Real-Time Kernel
*
*                          (c) Copyright 1992-2002, Jean J. Labrosse, Weston, FL
*                                           All Rights Reserved
*
*
*                                           uCOS_51 for MCS-51
*
* File : system.c
* Created by : QQ 591881218
*********************************************************************************************************
*/

#ifndef  OS_MASTER_FILE
#include "..\..\ucos-ii\inc\includes.h"
#endif
/*********************************************************************************/
void InitSystem(void) large reentrant // ϵͳʼ
{
	P_SW2 = 0x80;
	#ifdef Inter_IRC
		CLKSEL = 0x01;
	#elif Inter_32RC
		IRC32KCR = 0x80;
		while(!(IRC32KCR & 1));
		CLKDIV = 0x00;
		CLKSEL = 0x03;
	#else
		XOSCCR = 0xc0;
		while(!(XOSCCR & 1));
		CLKDIV = 0x00;
		CLKSEL = 0x01;	
	#endif
	
	OSInit();
	InitTimer0();	
	io_init();
	
	InitSerial(system_uart,115200);
	InitSerialBuffer();

}
/*********************************************************************************/
void LogoDisp(void) large reentrant // Logo display
{
	PrintStr("\n\t\t\t\t\t********************************\n");
   	PrintStr("\t\t\t\t\t*           uC/OS-II           *\n");
	PrintStr("\t\t\t\t\t*     The Real-Time Kernel     *\n");
	PrintStr("\t\t\t\t\t*      uCOS_51 for MCS-51      *\n");
    PrintStr("\t\t\t\t\t********************************\n\n\n");	
}

/*********************************************************************************/
/*IO口配置
          PnM0  0     0     1     1
          PnM1  0     1     0     1
		       双向  输入  输出  开漏
*/
/*********************************************************************************/
void io_init(void) large reentrant 
{
	#ifdef PUPS_DC
		P0M0 = 0x0a;  //设置P0.0,P0.2,P04~P0.7为输入模式
		P0M1 = 0xf5;  //设置P0.1,P0.3为输出模式
	
		P1M0 = 0x02;  //设置P1.0,P1.2~P1.7为输入模式
		P1M1 = 0xfd;  //设置P1.1为输出模式
		
		P2M0 = 0x00;  //设置P2为输入模式，没用到
		P2M1 = 0xff;
		
		P3M0 = 0x0e;  //设置P3.0,P3.4~P3.7为输入模式
		P3M1 = 0xf1;  //设置P3.1~P3.3为输出模式
		
		P5M0 = 0x00;  //设置P5为输入模式
		P5M1 = 0xff;
	#elif PUPS_AC
		P0M0 = 0x0a;  //设置P0.0,P0.2,P04~P0.7为输入模式
		P0M1 = 0xf5;  //设置P0.1,P0.3为输出模式
		
		P1M0 = 0x02;  //设置P1.0,P1.2~P1.7为输入模式
		P1M1 = 0xfd;  //设置P1.1为输出模式
		
		P2M0 = 0x00;  //设置P2为输入模式，没用到
		P2M1 = 0xff;
		
		P3M0 = 0x0e;  //设置P3.0,P3.4~P3.7为输入模式
		P3M1 = 0xf1;  //设置P3.1~P3.3为输出模式
		
		P5M0 = 0x00;  //设置P5为输入模式
		P5M1 = 0xff;
	#elif PUPS_3AC
		P0M0 = 0x00;  //设置P0为输入模式
		P0M1 = 0xff;  
		
		P1M0 = 0x11;  //设置P1.0,P1.4为输入模式
		P1M1 = 0xee;  
		
		P2M0 = 0x00;  //设置P2为输入模式，没用到
		P2M1 = 0xff;
		
		P3M0 = 0x0e;  //设置P3.0,P3.4~P3.7为输入模式
		P3M1 = 0xf1;  //设置P3.1~P3.3为输出模式
		
		P5M0 = 0x00;  //设置P5为输入模式
		P5M1 = 0xff;
	#else
		P0M0 = 0x00;  //设置P0为输入模式
		P0M1 = 0xff;  
		
		P1M0 = 0x00;  //设置P1为输入模式
		P1M1 = 0xff;  
		
		P2M0 = 0x00;  //设置P2为输入模式
		P2M1 = 0xff;
		
		P3M0 = 0x00;  //设置P3为输入模式
		P3M1 = 0xff;  
		
		P5M0 = 0x00;  //设置P5为输入模式
		P5M1 = 0xff;
	#endif
}
